/*
 *   xmcd - Motif CD Player
 *
 *   Copyright (C) 1994  Ti Kan
 *   E-mail: ti@amb.org
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */
#ifndef __AC_GEOM_H__
#define __AC_GEOM_H__

#ifndef LINT
static char *_ac_geom_h_ident_ = "@(#)ac_geom.h	2.2 94/02/18";
#endif

/* Location of widgets relative to form origin, express in percentage of
 * form size.
 */

/* Main window widgets */

#define LEFT_CHECKBOX		0
#define RIGHT_CHECKBOX		16
#define TOP_CHECKBOX		0
#define BOTTOM_CHECKBOX		60

#define LEFT_EJECT		0
#define RIGHT_EJECT		16
#define TOP_EJECT		60
#define BOTTOM_EJECT		80

#define LEFT_POWEROFF		0
#define RIGHT_POWEROFF		16
#define TOP_POWEROFF		80
#define BOTTOM_POWEROFF		100

#define LEFT_TRACKIND		19
#define RIGHT_TRACKIND		32
#define TOP_TRACKIND		4
#define BOTTOM_TRACKIND_1	32
#define BOTTOM_TRACKIND_2	36
#define BOTTOM_TRACKIND_3	41

#define LEFT_INDEXIND		32
#define RIGHT_INDEXIND		39
#define TOP_INDEXIND		4
#define BOTTOM_INDEXIND_1	32
#define BOTTOM_INDEXIND_2	36
#define BOTTOM_INDEXIND_3	41

#define LEFT_TIMEIND		39
#define RIGHT_TIMEIND		64
#define TOP_TIMEIND		4
#define BOTTOM_TIMEIND_1	32
#define BOTTOM_TIMEIND_2	36
#define BOTTOM_TIMEIND_3	41

#define LEFT_DBMODEIND		19
#define RIGHT_DBMODEIND		30
#define TOP_DBMODEIND_1		32
#define TOP_DBMODEIND_2		36
#define TOP_DBMODEIND_3		41
#define BOTTOM_DBMODEIND_1	46
#define BOTTOM_DBMODEIND_2	51
#define BOTTOM_DBMODEIND_3	61

#define LEFT_PROGMODEIND	30
#define RIGHT_PROGMODEIND	41
#define TOP_PROGMODEIND_1	32
#define TOP_PROGMODEIND_2	36
#define TOP_PROGMODEIND_3	41
#define BOTTOM_PROGMODEIND_1	46
#define BOTTOM_PROGMODEIND_2	51
#define BOTTOM_PROGMODEIND_3	61

#define LEFT_TIMEMODEIND	41
#define RIGHT_TIMEMODEIND	52
#define TOP_TIMEMODEIND_1	32
#define TOP_TIMEMODEIND_2	36
#define TOP_TIMEMODEIND_3	41
#define BOTTOM_TIMEMODEIND_1	46
#define BOTTOM_TIMEMODEIND_2	51
#define BOTTOM_TIMEMODEIND_3	61

#define LEFT_PLAYMODEIND	52
#define RIGHT_PLAYMODEIND	64
#define TOP_PLAYMODEIND_1	32
#define TOP_PLAYMODEIND_2	36
#define TOP_PLAYMODEIND_3	41
#define BOTTOM_PLAYMODEIND_1	46
#define BOTTOM_PLAYMODEIND_2	51
#define BOTTOM_PLAYMODEIND_3	61

#define LEFT_DTITLEIND		19
#define RIGHT_DTITLEIND		64
#define TOP_DTITLEIND_1		46
#define TOP_DTITLEIND_2		51
#define TOP_DTITLEIND_3		61
#define BOTTOM_DTITLEIND_1	54
#define BOTTOM_DTITLEIND_2	62
#define BOTTOM_DTITLEIND_3	61

#define LEFT_TTITLEIND		19
#define RIGHT_TTITLEIND		64
#define TOP_TTITLEIND_1		54
#define TOP_TTITLEIND_2		62
#define TOP_TTITLEIND_3		61
#define BOTTOM_TTITLEIND_1	63
#define BOTTOM_TTITLEIND_2	62
#define BOTTOM_TTITLEIND_3	61

#define LEFT_DBPROG		16
#define RIGHT_DBPROG		27
#define TOP_DBPROG		65
#define BOTTOM_DBPROG		100

#define LEFT_TIME		27
#define RIGHT_TIME		37
#define TOP_TIME		65
#define BOTTOM_TIME		80

#define LEFT_AB			37
#define RIGHT_AB		47
#define TOP_AB			65
#define BOTTOM_AB		80

#define LEFT_SAMPLE		47
#define RIGHT_SAMPLE		57
#define TOP_SAMPLE		65
#define BOTTOM_SAMPLE		80

#define LEFT_KEYPAD		57
#define RIGHT_KEYPAD		67
#define TOP_KEYPAD		65
#define BOTTOM_KEYPAD		80

#define LEFT_HELP		27
#define RIGHT_HELP		37
#define TOP_HELP		80
#define BOTTOM_HELP		100

#define LEFT_LEVEL		37
#define RIGHT_LEVEL		67
#define TOP_LEVEL		80
#define BOTTOM_LEVEL		100

#define LEFT_PLAYPAUSE		67
#define RIGHT_PLAYPAUSE		100
#define TOP_PLAYPAUSE		0
#define BOTTOM_PLAYPAUSE	20

#define LEFT_STOP		67
#define RIGHT_STOP		100
#define TOP_STOP		20
#define BOTTOM_STOP		40

#define LEFT_PREVTRK		67
#define RIGHT_PREVTRK		84
#define TOP_PREVTRK		40
#define BOTTOM_PREVTRK		60

#define LEFT_NEXTTRK		84
#define RIGHT_NEXTTRK		100
#define TOP_NEXTTRK		40
#define BOTTOM_NEXTTRK		60

#define LEFT_PREVIDX		67
#define RIGHT_PREVIDX		84
#define TOP_PREVIDX		60
#define BOTTOM_PREVIDX		80

#define LEFT_NEXTIDX		84
#define RIGHT_NEXTIDX		100
#define TOP_NEXTIDX		60
#define BOTTOM_NEXTIDX		80

#define LEFT_REW		67
#define RIGHT_REW		84
#define TOP_REW			80
#define BOTTOM_REW		100

#define LEFT_FF			84
#define RIGHT_FF		100
#define TOP_FF			80
#define BOTTOM_FF		100

/* Keypad window widgets */

#define LEFT_KEYPADLBL		5
#define RIGHT_KEYPADLBL		95
#define TOP_KEYPADLBL		5
#define BOTTOM_KEYPADLBL	11

#define LEFT_KEYPADIND		38
#define RIGHT_KEYPADIND		62
#define TOP_KEYPADIND		12
#define BOTTOM_KEYPADIND	23

#define LEFT_KEY1		5
#define RIGHT_KEY1		35
#define TOP_KEY1		28
#define BOTTOM_KEY1		39

#define LEFT_KEY2		35
#define RIGHT_KEY2		65
#define TOP_KEY2		28
#define BOTTOM_KEY2		39

#define LEFT_KEY3		65
#define RIGHT_KEY3		95
#define TOP_KEY3		28
#define BOTTOM_KEY3		39

#define LEFT_KEY4		5
#define RIGHT_KEY4		35
#define TOP_KEY4		39
#define BOTTOM_KEY4		50

#define LEFT_KEY5		35
#define RIGHT_KEY5		65
#define TOP_KEY5		39
#define BOTTOM_KEY5		50

#define LEFT_KEY6		65
#define RIGHT_KEY6		95
#define TOP_KEY6		39
#define BOTTOM_KEY6		50

#define LEFT_KEY7		5
#define RIGHT_KEY7		35
#define TOP_KEY7		50
#define BOTTOM_KEY7		61

#define LEFT_KEY8		35
#define RIGHT_KEY8		65
#define TOP_KEY8		50
#define BOTTOM_KEY8		61

#define LEFT_KEY9		65
#define RIGHT_KEY9		95
#define TOP_KEY9		50
#define BOTTOM_KEY9		61

#define LEFT_KEY0		5
#define RIGHT_KEY0		35
#define TOP_KEY0		61
#define BOTTOM_KEY0		72

#define LEFT_ENTER		35
#define RIGHT_ENTER		95
#define TOP_ENTER		61
#define BOTTOM_ENTER		72

#define LEFT_KEYPADSEP		0
#define RIGHT_KEYPADSEP		100
#define TOP_KEYPADSEP		77

#define LEFT_KPCLEAR		5
#define RIGHT_KPCLEAR		45
#define TOP_KPCLEAR		84

#define LEFT_KPCANCEL		55
#define RIGHT_KPCANCEL		95
#define TOP_KPCANCEL		84

/* Database/Program window widgets */

#define LEFT_LOGO		32
#define RIGHT_LOGO		52
#define TOP_LOGO		1
#define BOTTOM_LOGO		11

#define LEFT_ABOUT		81
#define RIGHT_ABOUT		96
#define TOP_ABOUT		2
#define BOTTOM_ABOUT		7

#define LEFT_DTITLELBL		4
#define RIGHT_DTITLELBL		79
#define TOP_DTITLELBL		11
#define BOTTOM_DTITLELBL	15

#define LEFT_EXTDLBL		81
#define RIGHT_EXTDLBL		96
#define TOP_EXTDLBL		11
#define BOTTOM_EXTDLBL		15

#define LEFT_DTITLE		4
#define RIGHT_DTITLE		79
#define TOP_DTITLE		15
#define BOTTOM_DTITLE		22

#define LEFT_EXTD		81
#define RIGHT_EXTD		96
#define TOP_EXTD		15
#define BOTTOM_EXTD		21

#define LEFT_DBPROGSEP1		0
#define RIGHT_DBPROGSEP1	100
#define TOP_DBPROGSEP1		24

#define LEFT_TRKLISTLBL		4
#define RIGHT_TRKLISTLBL	79
#define TOP_TRKLISTLBL		26
#define BOTTOM_TRKLISTLBL	30

#define LEFT_TRKLIST		4
#define RIGHT_TRKLIST		79
#define TOP_TRKLIST		30
#define BOTTOM_TRKLIST		61

#define LEFT_RADIOLBL		81
#define RIGHT_RADIOLBL		96
#define TOP_RADIOLBL		46
#define BOTTOM_RADIOLBL		50

#define LEFT_RADIOBOX		81
#define RIGHT_RADIOBOX		96
#define TOP_RADIOBOX		50
#define BOTTOM_RADIOBOX		61

#define LEFT_DISCIDLBL		81
#define RIGHT_DISCIDLBL		96
#define TOP_DISCIDLBL		76
#define BOTTOM_DISCIDLBL	80

#define LEFT_DISCIDIND		80
#define RIGHT_DISCIDIND		97
#define TOP_DISCIDIND		80
#define BOTTOM_DISCIDIND	84

#define LEFT_TTITLELBL		4
#define RIGHT_TTITLELBL		79
#define TOP_TTITLELBL		62
#define BOTTOM_TTITLELBL	66

#define LEFT_EXTTLBL		81
#define RIGHT_EXTTLBL		96
#define TOP_EXTTLBL		62
#define BOTTOM_EXTTLBL		66

#define LEFT_TTITLE		4
#define RIGHT_TTITLE		79
#define TOP_TTITLE		66
#define BOTTOM_TTITLE		73

#define LEFT_EXTT		81
#define RIGHT_EXTT		96
#define TOP_EXTT		66
#define BOTTOM_EXTT		72

#define LEFT_PGMLBL		81
#define RIGHT_PGMLBL		96
#define TOP_PGMLBL		26
#define BOTTOM_PGMLBL		30

#define LEFT_ADDPGM		81
#define RIGHT_ADDPGM		96
#define TOP_ADDPGM		30
#define BOTTOM_ADDPGM		35

#define LEFT_CLRPGM		81
#define RIGHT_CLRPGM		96
#define TOP_CLRPGM		35
#define BOTTOM_CLRPGM		40

#define LEFT_PLAYPGM		81
#define RIGHT_PLAYPGM		96
#define TOP_PLAYPGM		40
#define BOTTOM_PLAYPGM		45

#define LEFT_PGMSEQLBL		4
#define RIGHT_PGMSEQLBL		79
#define TOP_PGMSEQLBL		73
#define BOTTOM_PGMSEQLBL	77

#define LEFT_PGMSEQ		4
#define RIGHT_PGMSEQ		79
#define TOP_PGMSEQ		77
#define BOTTOM_PGMSEQ		84

#define LEFT_DBPROGSEP2		0
#define RIGHT_DBPROGSEP2	100
#define TOP_DBPROGSEP2		87

#define LEFT_SAVEDB		6
#define RIGHT_SAVEDB		25
#define TOP_SAVEDB		91

#define LEFT_LINK		29
#define RIGHT_LINK		48
#define TOP_LINK		91

#define LEFT_LOADDB		52
#define RIGHT_LOADDB		71
#define TOP_LOADDB		91

#define LEFT_DPCANCEL		75
#define RIGHT_DPCANCEL		94
#define TOP_DPCANCEL		91

/* Disc Extended Info editor widgets */

#define LEFT_DISCLBL		3
#define RIGHT_DISCLBL		97
#define TOP_DISCLBL		3
#define BOTTOM_DISCLBL		8

#define LEFT_EXTDTXT		3
#define RIGHT_EXTDTXT		97
#define TOP_EXTDTXT		10
#define BOTTOM_EXTDTXT		80

#define LEFT_DBEXTDSEP		0
#define RIGHT_DBEXTDSEP		100
#define TOP_DBEXTDSEP		84

#define LEFT_DDOK		10
#define RIGHT_DDOK		30
#define TOP_DDOK		89

#define LEFT_DDCLEAR		40
#define RIGHT_DDCLEAR		60
#define TOP_DDCLEAR		89

#define LEFT_DDCANCEL		70
#define RIGHT_DDCANCEL		90
#define TOP_DDCANCEL		89

/* Track Extended Info editor widgets */

#define LEFT_TRKLBL		3
#define RIGHT_TRKLBL		97
#define TOP_TRKLBL		3
#define BOTTOM_TRKLBL		8

#define LEFT_EXTTTXT		3
#define RIGHT_EXTTTXT		97
#define TOP_EXTTTXT		10
#define BOTTOM_EXTTTXT		80

#define LEFT_DBEXTTSEP		0
#define RIGHT_DBEXTTSEP		100
#define TOP_DBEXTTSEP		84

#define LEFT_DTOK		10
#define RIGHT_DTOK		30
#define TOP_DTOK		89

#define LEFT_DTCLEAR		40
#define RIGHT_DTCLEAR		60
#define TOP_DTCLEAR		89

#define LEFT_DTCANCEL		70
#define RIGHT_DTCANCEL		90
#define TOP_DTCANCEL		89

/* Help popup widgets */

#define LEFT_HELPTXT		3
#define RIGHT_HELPTXT		97
#define TOP_HELPTXT		5
#define BOTTOM_HELPTXT		80

#define LEFT_HELPSEP		0
#define RIGHT_HELPSEP		100
#define TOP_HELPSEP		84

#define LEFT_HELPOK		40
#define RIGHT_HELPOK		60
#define TOP_HELPOK		89

/* Directory selector popup widgets */

#define LEFT_DIRLBL		4
#define RIGHT_DIRLBL		96
#define TOP_DIRLBL		4
#define BOTTOM_DIRLBL		10

#define LEFT_DIRLIST		4
#define RIGHT_DIRLIST		96
#define TOP_DIRLIST		14
#define BOTTOM_DIRLIST		67

#define LEFT_DIRSELSEP		0
#define RIGHT_DIRSELSEP		100
#define TOP_DIRSELSEP		74

#define LEFT_DSOK		5
#define RIGHT_DSOK		40
#define TOP_DSOK		82

#define LEFT_DSCANCEL		60
#define RIGHT_DSCANCEL		95
#define TOP_DSCANCEL		82

/* Link selector popup widgets */

#define LEFT_LINKLBL		3
#define RIGHT_LINKLBL		97
#define TOP_LINKLBL		4
#define BOTTOM_LINKLBL		10

#define LEFT_LINKLIST		3
#define RIGHT_LINKLIST		97
#define TOP_LINKLIST		14
#define BOTTOM_LINKLIST		67

#define LEFT_LINKSELSEP		0
#define RIGHT_LINKSELSEP	100
#define TOP_LINKSELSEP		74

#define LEFT_LSOK		10
#define RIGHT_LSOK		37
#define TOP_LSOK		82

#define LEFT_LSCANCEL		63
#define RIGHT_LSCANCEL		90
#define TOP_LSCANCEL		82


/* Public function prototypes */
extern void	force_geometry(widgets_t *);

#endif	/* __AC_GEOM_H__ */

