#!/bin/sh
#
# @(#)makesrc.sh	2.20 94/02/15
#
# Make xmcd source code release
#
#    xmcd - Motif(tm) CD Audio Player
#
#    Copyright (C) 1994  Ti Kan
#    E-mail: ti@amb.org
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#

FILES="	Imakefile \
	BUGS \
	COPYING \
	INSTALL \
	CHANGES \
	PORTING \
	README \
	demo.cddb \
	xmcd.man \
	XMcd.ad \
	XKeysymDB \
	dev.config \
	install.sh \
	configure.sh \
	makerel.sh \
	makesrc.sh \
	xmcd.h \
	patchlevel.h \
	ac_cdfunc.h \
	ac_dbprog.h \
	ac_geom.h \
	ac_help.h \
	ac_hotkey.h \
	ac_resrc.h \
	ac_util.h \
	ac_widget.h \
	di_lib.h \
	di_scsipt.h \
	os_aix.h \
	os_dec.h \
	os_hpux.h \
	os_irix.h \
	os_linux.h \
	os_odt.h \
	os_sun.h \
	os_svr4.h \
	os_cdsim.h \
	os_demo.h \
	vu_chin.h \
	vu_hita.h \
	vu_nec.h \
	vu_pion.h \
	vu_sony.h \
	vu_tosh.h \
	ac_cdfunc.c \
	ac_dbprog.c \
	ac_geom.c \
	ac_help.c \
	ac_hotkey.c \
	ac_main.c \
	ac_util.c \
	ac_widget.c \
	di_scsipt.c \
	os_aix.c \
	os_dec.c \
	os_hpux.c \
	os_irix.c \
	os_linux.c \
	os_odt.c \
	os_sun.c \
	os_svr4.c \
	os_demo.c \
	os_cdsim.c \
	vu_chin.c \
	vu_hita.c \
	vu_nec.c \
	vu_pion.c \
	vu_sony.c \
	vu_tosh.c \
	bitmaps/ab.xbm \
	bitmaps/btnlbl.xbm \
	bitmaps/dbprog.xbm \
	bitmaps/eject.xbm \
	bitmaps/ff.xbm \
	bitmaps/help.xbm \
	bitmaps/keypad.xbm \
	bitmaps/lock.xbm \
	bitmaps/logo.xbm \
	bitmaps/nextidx.xbm \
	bitmaps/nexttrk.xbm \
	bitmaps/playpaus.xbm \
	bitmaps/poweroff.xbm \
	bitmaps/previdx.xbm \
	bitmaps/prevtrk.xbm \
	bitmaps/repeat.xbm \
	bitmaps/rew.xbm \
	bitmaps/sample.xbm \
	bitmaps/shuffle.xbm \
	bitmaps/stop.xbm \
	bitmaps/time.xbm \
	bitmaps/xmcd.xbm \
	cfgtbl/Apple \
	cfgtbl/Chinon \
	cfgtbl/Compaq \
	cfgtbl/DEC \
	cfgtbl/Hitachi \
	cfgtbl/IBM \
	cfgtbl/NEC \
	cfgtbl/Pioneer \
	cfgtbl/Plextor \
	cfgtbl/Procom \
	cfgtbl/Sony \
	cfgtbl/Sun \
	cfgtbl/Toshiba \
	helpfiles/AbBtn \
	helpfiles/CheckBox \
	helpfiles/DbModeInd \
	helpfiles/DbProgBtn \
	helpfiles/DdCancelBtn \
	helpfiles/DdClrBtn \
	helpfiles/DdDiscTxt \
	helpfiles/DdOkBtn \
	helpfiles/DiscIdInd \
	helpfiles/DiscTitleInd \
	helpfiles/DpAboutBtn \
	helpfiles/DpAddPgmBtn \
	helpfiles/DpCancelBtn \
	helpfiles/DpClrPgmBtn \
	helpfiles/DpDExtBtn \
	helpfiles/DpDTitleTxt \
	helpfiles/DpLinkBtn \
	helpfiles/DpLoadBtn \
	helpfiles/DpPgmSeqTxt \
	helpfiles/DpPlayPgmBtn \
	helpfiles/DpSaveBtn \
	helpfiles/DpTExtBtn \
	helpfiles/DpTTitleTxt \
	helpfiles/DpTimeSelBtn \
	helpfiles/DpTrkList \
	helpfiles/DsCancelBtn \
	helpfiles/DsDirList \
	helpfiles/DsOkBtn \
	helpfiles/DtCancelBtn \
	helpfiles/DtClrBtn \
	helpfiles/DtOkBtn \
	helpfiles/DtTrackTxt \
	helpfiles/EjectBtn \
	helpfiles/FfBtn \
	helpfiles/HelpBtn \
	helpfiles/IndexInd \
	helpfiles/KeypadBtn \
	helpfiles/KeypadInd \
	helpfiles/KpCancelBtn \
	helpfiles/KpClearBtn \
	helpfiles/KpEnterBtn \
	helpfiles/KpNumBtn \
	helpfiles/LevelScale \
	helpfiles/LsCancelBtn \
	helpfiles/LsLinkList \
	helpfiles/LsOkBtn \
	helpfiles/NextIdxBtn \
	helpfiles/NextTrkBtn \
	helpfiles/PlayModeInd \
	helpfiles/PlayPauseBtn \
	helpfiles/PowerBtn \
	helpfiles/PrevIdxBtn \
	helpfiles/PrevTrkBtn \
	helpfiles/ProgModeInd \
	helpfiles/RewBtn \
	helpfiles/SampleBtn \
	helpfiles/StopBtn \
	helpfiles/TimeBtn \
	helpfiles/TimeInd \
	helpfiles/TimeModeInd \
	helpfiles/TrackInd \
	helpfiles/TrackTitleInd \
	wm2xmcd/Imakefile \
	wm2xmcd/wm2xmcd.c \
	wm2xmcd/wm2xmcd.man"


# Use Sysv echo if possible
if [ -x /usr/5bin/echo ]				# SunOS SysV echo
then
	ECHO=/usr/5bin/echo
elif [ -z "`(echo -e a) 2>/dev/null | fgrep e`" ]	# GNU bash, etc.
then
	ECHO="echo -e"
else							# generic SysV
	ECHO=echo
fi

# Create tar archive
tar cf xmcdsrc.tar $FILES

# Compress tar archive
compress xmcdsrc.tar

$ECHO '

Instructions to unpack xmcd source code release
-----------------------------------------------

The following is a compressed and uuencoded tar archive containing
the xmcd source code files.  To extract, make a suitable source
code directory for xmcd and save this message in a file "xmcdsrc.uue"
in that directory.  Then, change to the directory and do the following:

	uudecode xmcdsrc.uue
	uncompress xmcdsrc.tar.Z
	tar xvf xmcdsrc.tar

Read the README and INSTALL files for further instructions.

' >xmcdsrc.uue

# Uuencode
uuencode xmcdsrc.tar.Z xmcdsrc.tar.Z >>xmcdsrc.uue

rm -f xmcdsrc.tar.Z
ls -l xmcdsrc.uue
exit 0

